/*
 Copyright (c) 2006-2016 Trellis Management Co. Ltd.

 This software module is an implementation of one or more tools as proposed
 for the JPEG XT standard.
 
 The copyright in this software is being made available under the
 license included with the sources LICENSE.TXT. This software may be subject to other third
 party and contributor rights, including patent rights, and no such
 rights are granted under this license. 
*/
#include "checksum.h"

unsigned short Fletcher16( unsigned char* data, int data_size, unsigned short c0, unsigned short c1, unsigned short *oc0, unsigned short *oc1 )
{
   unsigned short sum1 = c0;
   unsigned short sum2 = c1;
   int index;

   for( index = 0; index < data_size; ++index )
   {
      sum1 = (sum1 + data[index]) % 255;
      sum2 = (sum2 + sum1) % 255;
   }
   *oc0=sum1;
   *oc1=sum2;
   return (sum2 << 8) | sum1;
}

